diff -rNau ./uisp-20040311/src/DAPA.C ./uisp-20040311-casc/src/DAPA.C
--- ./uisp-20040311/src/DAPA.C	Sat Feb  7 21:54:06 2004
+++ ./uisp-20040311-casc/src/DAPA.C	Sun Nov 28 19:41:59 2004
@@ -492,6 +492,15 @@
     ioctl(ppdev_fd, b ? TIOCCBRK : TIOCSBRK, 0);
 #endif /* TIOCMGET */
     break;
+
+  case PAT_CASC:	
+    int val = TIOCM_DTR;
+    if(b) { 
+	ioctl(ppdev_fd, TIOCMBIC, &val);	/* reset=1 */
+    } else {
+	ioctl(ppdev_fd, TIOCMBIS, &val);	/* reset=0 */
+    }
+    break;
   }
   Delay_usec(b ? reset_high_time : RESET_LOW_TIME );
 }
@@ -569,6 +578,15 @@
     SerialWriteCtrl();
 #endif /* TIOCMGET */
     break;
+
+  case PAT_CASC:
+    int val = TIOCM_RTS;
+    if(b) {
+	ioctl(ppdev_fd, TIOCMBIS, &val);	/* sck=0 */
+    } else {
+	ioctl(ppdev_fd, TIOCMBIC, &val);	/* sck=1 */
+    }
+    break;
   }
 }
 
@@ -679,6 +697,7 @@
 
   case PAT_DASA:
   case PAT_DASA2:
+  case PAT_CASC:
     break;
   }
 }
@@ -706,6 +725,7 @@
   case PAT_XIL:
   case PAT_DASA:
   case PAT_DASA2:
+  case PAT_CASC:
     /* no separate enable for SCK nad MOSI */
     break;
   }
@@ -799,6 +819,11 @@
     SerialWriteCtrl();
 #endif /* TIOCMGET */
     break;
+
+  case PAT_CASC:
+    /* send data bit */
+    ioctl (ppdev_fd, b ? TIOCCBRK : TIOCSBRK, 0);
+    break;
   }
 }
 
@@ -840,6 +865,12 @@
     b = (ser_ctrl & TIOCM_CTS);
 #endif /* TIOCMGET */
     break;
+
+  case PAT_CASC:
+    int val;
+    ioctl (ppdev_fd, TIOCMGET, &val);
+    b = !(val & TIOCM_CTS);
+    break;
   }
   if (miso_invert)
     b = !b;
@@ -900,6 +931,7 @@
 
   case PAT_DASA:
   case PAT_DASA2:
+  case PAT_CASC:
     break;
   }
 
@@ -1006,10 +1038,12 @@
     pa_type = PAT_DASA;
   else if (val && strcmp(val, "dasa2") == 0)
     pa_type = PAT_DASA2;
+  else if (val && strcmp(val, "casc") == 0)
+    pa_type = PAT_CASC;
   else {
     throw Error_Device("Direct Parallel Access not defined.");
   }
-  pa_type_is_serial = (pa_type == PAT_DASA || pa_type == PAT_DASA2);
+  pa_type_is_serial = (pa_type == PAT_DASA || pa_type == PAT_DASA2 || pa_type == PAT_CASC);
   /* Parse Command Line Switches */
 #ifndef NO_DIRECT_IO
   if ((val = GetCmdParam("-dlpt")) != NULL) {
diff -rNau ./uisp-20040311/src/DAPA.h ./uisp-20040311-casc/src/DAPA.h
--- ./uisp-20040311/src/DAPA.h	Sat Feb  7 21:54:06 2004
+++ ./uisp-20040311-casc/src/DAPA.h	Sun Nov 28 17:57:45 2004
@@ -45,7 +45,7 @@
 public:
   enum TPaType{	PAT_DAPA, PAT_STK200, PAT_ABB, PAT_PARAVRISP, PAT_BSD,
 		PAT_FBPRG, PAT_DT006, PAT_ETT, PAT_MAXI, PAT_XIL,
-		PAT_DASA, PAT_DASA2 };
+		PAT_DASA, PAT_DASA2, PAT_CASC};
 
 private:
   int mosi_invert;
diff -rNau ./uisp-20040311/src/Main.C ./uisp-20040311-casc/src/Main.C
--- ./uisp-20040311/src/Main.C	Sat Feb  7 21:54:06 2004
+++ ./uisp-20040311-casc/src/Main.C	Sun Nov 28 20:02:47 2004
@@ -87,7 +87,7 @@
 "         avrisp    Atmel AVRISP (uses stk500 protocol, but can only perform\n"
 "                   serial programming using SPI)\n"
 #ifndef NO_DAPA
-"  -dprog=dapa|stk200|abb|avrisp|bsd|fbprg|dt006|maxi|xil|dasa|dasa2\n"
+"  -dprog=dapa|stk200|abb|avrisp|bsd|fbprg|dt006|maxi|xil|dasa|dasa2|casc\n"
 "       Programmer type:\n"
 "         dapa      Direct AVR Parallel Access\n"
 "         stk200    Parallel Starter Kit STK200, STK300\n"
@@ -101,6 +101,7 @@
 "         ett       ETT AVR Programmer V2.0 [from Futurlec] (parallel)\n"
 "         dasa      serial (RESET=RTS SCK=DTR MOSI=TXD MISO=CTS)\n"
 "         dasa2     serial (RESET=!TXD SCK=RTS MOSI=DTR MISO=CTS)\n"
+"         casc      serial (http://www.vak.ru/proj/casc/)\n"
 "\n"
 "Target Device Selection:\n"
 "  -dpart       Set  target abbreviated name or number. For some programmers, if\n"
diff -rNau ./uisp-20040311/uisp.1.in ./uisp-20040311-casc/uisp.1.in
--- ./uisp-20040311/uisp.1.in	Sat Feb  7 21:54:06 2004
+++ ./uisp-20040311-casc/uisp.1.in	Sun Nov 28 20:14:56 2004
@@ -20,7 +20,7 @@
 Atmel STK500
 .RE
 .HP
-\fB\-dprog\fR=dapa|stk200|abb|avrisp|bsd|fbprg|dt006|maxi|dasa|dasa2
+\fB\-dprog\fR=dapa|stk200|abb|avrisp|bsd|fbprg|dt006|maxi|dasa|dasa2|casc
 .RS
 .TP
 dapa
@@ -52,6 +52,9 @@
 .TP
 dasa2
 serial (RESET=!TXD SCK=RTS MOSI=DTR MISO=CTS)
+.TP
+casc
+serial (http://www.vak.ru/proj/casc)
 .RE
 .SS "Target Device Selection:"
 .TP